package com.unissoft.interaction.controller;

import com.unissoft.interaction.algorithm.CylinderAlg;
import com.unissoft.interaction.entity.TeData;
import com.unissoft.interaction.service.SquareService;
import com.unissoft.interaction.service.TeDataService;
import com.unissoft.systemManage.model.OrgInfo;
import com.unissoft.systemManage.service.OrgInfoService;

import java.util.Collections;
import java.util.Date;
import java.util.List;

import javax.annotation.Resource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
public class DataController {

    private static final Logger logger = LoggerFactory.getLogger(DataController.class);

    private TeDataService teDataService;

    private SquareService squareService;

    @Autowired
    public void setTeDataService(TeDataService teDataService) {
        this.teDataService = teDataService;
    }
    
    @Autowired
    public void setSquareService(SquareService squareService) {
        this.squareService = squareService;
    }
    
    

    @Resource
    private OrgInfoService orgInfoService;
    
    /**
     * 检测后数据
     *
     * @param teData
     * @return
     */
    @PostMapping("/equipmentTestingEnd")
    public String equipmentTesting(@RequestBody TeData teData) {
        logger.info("接收到硬件的数据为{}", teData);
        teData.setEtime(new Date());
        //根据唯一的taskId(仓房id+自然增长id)获取仓房id
        String houseId = teData.getTaskID().split(",")[0];	
        OrgInfo orgInfoHouse = orgInfoService.getById(Integer.parseInt(houseId));
        
        
        int inum = teDataService.saveTeData(teData); //打点数据返回
        if (inum < 0) {
            return "fail";
        }
        
        //查询仓房信息 判断是平房仓还是圆筒仓
       
   	    String houseType = orgInfoHouse.getHouseType();
        //20 筒仓  21 平房仓
   	    if(houseType.equals("20")){
   	        teDataService.scanTask(teData);//进行下一次的打点
   	    }else if(houseType.equals("21")){
   	    	squareService.scanTask(teData); //下一次打点
   	    }
        
        
        /*
         * 判断是否校准
         * 
         * if(!teData.getRotationxy().contains(";")){ //判断是否校准
        	//打一个点  只返回一组数据
        	String high = orgInfoHouse.getHigh();//仓房的高
     		String radius = orgInfoHouse.getRadius();//仓房的半径
     		Double diameter = Double.parseDouble(radius)*2;//直径
     		Double h = Double.parseDouble(high);
     		String intPegPoint = "1616";//获取零点校准时 垂直打在仓壁的距离  单位是毫米
 	        //判断是否校准
     		String calibrateDistance = teData.getRotationxy().split(",")[2];
     		System.out.println(teData.getRotationxy()+"返回值:"+calibrateDistance);
 	        int difference = Integer.parseInt(calibrateDistance)-Integer.parseInt(intPegPoint);
 	        if(Math.abs(difference)<10){//暂时差距定为10毫米  在这个范围内都符合条件
 	        	StandardUtils.setStandard(true);
 	        	System.out.println(1);
 	        	
 	        }else{
 	        	StandardUtils.setStandard(false);
 	        	System.out.println(12);
 	        }
        	
        }else{
        	int inum = teDataService.saveTeData(teData); //打点数据返回
            if (inum < 0) {
                return "fail";
            }
            
            //查询仓房信息 判断是平房仓还是圆筒仓
           
       	    String houseType = orgInfoHouse.getHouseType();
            //20 筒仓  21 平房仓
       	    if(houseType.equals("20")){
       	        teDataService.scanTask(teData);//进行下一次的打点
       	    }else if(houseType.equals("21")){
       	    	squareService.scanTask(teData); //下一次打点
       	    }
            
        }*/
        
        return "success";
    }

    /**
     * 用于测试
     * @param height
     * @param diameter 直径
     */
    @GetMapping("/scanning")
    public void scanning(@RequestParam(value = "height", defaultValue = "35") double height,
                         @RequestParam(value = "diameter", defaultValue = "12") double diameter,
                         @RequestParam(value = "cfId") String cfId) {

        logger.info("scanning cfId {},height{},diameter{}", cfId,height, diameter);
        teDataService.scanTask(cfId,diameter, height);
        //teDataService.scanTask("44", diameter, height);
    }
    
    
    /**
     * 判断是否校准
     */
    @GetMapping("/calibration")
    public void calibration(@RequestParam(value = "height") double height,
                         @RequestParam(value = "diameter") double diameter,
                         @RequestParam(value = "cfId") String cfId) {

        logger.info("scanning cfId {},height{},diameter{}", cfId,height, diameter);
        
        teDataService.calibration(cfId,diameter,height);//校准
    }
    
    /**
     * 测试-----------------
     * @param args
     */
    public static void main(String[] args) {
    	
    	double diameter = 12;
    	double h = 35;
    	String a = "550,4500,12510;500,4050,12513;400,4500,12516;-500,-4050,6542;650,4500,12523;600,3950,12520;"
    			+ "500,3600,12524;400,3650,12493;350,4500,12477;-400,-3650,7658;-500,-3600,6589;-600,-3950,5692;"
    			+ "700,4500,12522;700,4000,12522;650,3550,12523;550,3150,12523;400,3000,12488;300,3300,12444;"
    			+ "250,4500,12398;-300,-3300,9077;-400,-3000,7688;-550,-3150,6087;-650,-3550,5323;-700,-4000,5003;"
    			+ "800,4500,12521;800,4050,12522;750,3650,12524;700,3200,12524;600,2850,12524;500,2550,12514;"
    			+ "350,2400,12458;250,2700,12377;150,4100,12290;-200,-3050,11714;-300,-2450,9415;-450,-2450,7153;"
    			+ "-550,-2750,6130;-650,-3100,5341;-700,-3500,5010;-750,-3900,4734;850,4500,12523;850,4100,12522;"
    			+ "850,3700,12522;800,3300,12521;700,2900,12523;650,2500,12526;550,2150,12514;400,1850,12476;"
    			+ "300,1700,12423;150,1950,12283;100,4500,12249;-150,-1950,11985;-300,-1700,9426;-400,-1850,7802;"
    			+ "-550,-2150,6150;-650,-2500,5350;-700,-2900,5019;-800,-3300,4496;-850,-3700,4268;-850,-4100,4268;"
    			+ "950,4500,12532;950,4150,12532;900,3750,12538;900,3400,12537;850,3000,12539;750,2600,12521;"
    			+ "700,2250,12523;600,1850,12524;500,1500,12511;350,1150,12457;250,750,12374;150,350,12297;0,0,12120;"
    			+ "-150,-350,11988;-250,-750,10584;-350,-1150,8573;-500,-1500,6678;-600,-1850,5739;-700,-2250,5042;"
    			+ "-750,-2600,4767;-850,-3000,4268;-900,-3400,3881;-900,-3750,3881;-950,-4150,3661;500,4500,12475";
    	
    	String a1 = "550,0,1641;500,-450,1642;400,0,1631;500,450,1637;650,0,1655;600,-550,1653;500,-900,1640;400,-850,1630;350,0,1626;400,850,1630;500,900,1638;600,550,1649;700,0,1662;700,-500,1663;650,-950,1660;550,-1350,1647;400,-1500,1611;300,-1200,1591;250,0,1621;300,1200,0;400,1500,1629;550,1350,1645;650,950,1657;700,500,1663;800,0,1680;800,-450,1679;750,-850,1679;700,-1300,1670;600,-1650,1654;500,-1950,1641;350,-2100,1592;250,-1800,0;150,-400,1616;200,1450,1617;300,2050,1622;450,2050,1633;550,1750,1644;650,1400,0;700,1000,1669;750,600,1672;850,0,1688;850,-400,1689;850,-800,1688;800,-1200,1686;700,-1600,1669;650,-2000,1654;550,-2350,1647;400,-2650,1632;300,-2800,1624;150,-2550,1617;100,0,1616;150,2550,1617;300,2800,1623;400,2650,1630;550,2350,1644;650,2000,1665;700,1600,0;800,1200,1688;850,800,0;850,400,1698;950,0,1710;950,-350,1711;900,-750,1707;900,-1100,1708;850,-1500,1698;750,-1900,1679;700,-2250,0;600,-2650,1655;500,-3000,0;350,-3350,1628;250,-3750,1621;150,-4150,1619;0,0,1616;150,4150,0;250,3750,1622;350,3350,0;500,3000,1640;600,2650,1660;700,2250,1670;750,1900,1676;850,1500,1694;900,1100,1703;900,750,1705;950,350,1719;500,0,1642";
		String a2= "550,4500,12498;500,4050,12493;400,4500,12492;-500,-4050,6589;650,4500,12513;600,3950,12514;500,3600,12513;400,3650,12490;350,4500,12470;-400,-3650,7728;-500,-3600,6640;-600,-3950,5725;700,4500,12523;700,4000,12523;650,3550,12522;550,3150,12524;400,3000,12480;300,3300,12442;250,4500,12414;-300,-3300,9377;-400,-3000,7793;-550,-3150,6186;-650,-3550,5372;-700,-4000,5045;800,4500,12522;800,4050,12522;750,3650,12522;700,3200,12523;600,2850,12524;500,2550,12513;350,2400,12462;250,2700,12408;150,4100,12329;-200,-3050,11964;-300,-2450,9518;-450,-2450,7209;-550,-2750,6233;-650,-3100,5388;-700,-3500,5066;-750,-3900,4781;850,4500,12523;850,4100,12523;850,3700,12523;800,3300,12522;700,2900,12523;650,2500,12520;550,2150,12523;400,1850,12480;300,1700,12445;150,1950,12329;100,4500,12276;-150,-1950,11981;-300,-1700,9615;-400,-1850,7898;-550,-2150,6251;-650,-2500,5408;-700,-2900,5078;-800,-3300,4526;-850,-3700,4273;-850,-4100,4272;950,4500,12529;950,4150,12527;900,3750,12536;900,3400,12538;850,3000,12536;750,2600,12523;700,2250,12520;600,1850,12522;500,1500,12513;350,1150,12469;250,750,12417;150,350,12330;0,0,12173;-150,-350,11978;-250,-750,10866;-350,-1150,8725;-500,-1500,6752;-600,-1850,5818;-700,-2250,5090;-750,-2600,4806;-850,-3000,4299;-900,-3400,3916;-900,-3750,3912;-950,-4150,3687;500,4500,12470";
    	List<Double> zList = CylinderAlg.getValidZ(a2,diameter, h);
		double z = Collections.max(zList);//纵坐标的最大值
		double secondH = h - z;//仓房的高-点的纵坐标
        String rotationxy = CylinderAlg.getAveragePosition1(diameter, secondH);
        //System.out.println("最大值:"+rotationxy);
		
		double z1 = Collections.min(zList);//纵坐标的最小值
		//第二次打点的高
		double secondH1 = h - z1;//仓房的高-点的纵坐标
        //打点
        String rotationxy1 = CylinderAlg.getAveragePosition1(diameter, secondH1);
        //System.out.println("最小值:"+rotationxy1);
        System.out.println(z+"-------------"+z1);

	}
    
    
  
   
}
