package com.unissoft.interaction.controller;


import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.PageParam;
import com.unissoft.common.ResultView;
import com.unissoft.common.SystemLog;
import com.unissoft.interaction.entity.DensityData;
import com.unissoft.interaction.service.DensityDataService;

import io.swagger.annotations.ApiOperation;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author MySunshine
 * @since 2022-05-17
 */
@RestController
@RequestMapping("/density-data")
public class DensityDataController {

	private DensityDataService densityDataService;

    @Autowired
    public void setDensityDataController(DensityDataService densityDataService) {
        this.densityDataService = densityDataService;
    }
    
    /**
     * 分页查询列表
     * @param pageParam
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "密度参数", operDesc = "查询分页密度参数")
    @PostMapping("/getPage")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        IPage<DensityData> page = densityDataService.getPage(pageParam);
        return ResultView.success(page);
    }
    
   

    /**
     * 新增
     * @param densityData
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "密度参数", operDesc = "密度参数新增")
    @PostMapping("/save")
    public ResultView saveUser(@RequestBody DensityData densityData) {
    	densityData.setEditTime(new Date());
        boolean save = densityDataService.save(densityData);
        if (save)
            return ResultView.success();
        else
            return ResultView.error();
    }

    /**
     * 修改
     * @param densityData
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "密度参数", operDesc = "密度参数修改")
    @PostMapping("/update")
    public ResultView updateUser(@RequestBody DensityData densityData) {
        boolean b = densityDataService.updateById(densityData);
        if (b)
            return ResultView.success();
        else
            return ResultView.error();
    }
    
    
    /**
	 * 删除
	 * @param id
	 * @return
	 */
    @SystemLog(operModul = "参数设置", operType = "密度参数", operDesc = "密度参数删除")
    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/deleteById/{id}")
    public ResultView deleteById(@PathVariable Integer id) {
    	boolean b = densityDataService.removeById(id);
    	if (b)
            return ResultView.success();
        else
            return ResultView.error();
    }
}
