package com.unissoft.interaction.controller;



import javax.annotation.Resource;

import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.PageParam;
import com.unissoft.common.ResultView;
import com.unissoft.common.SystemLog;
import com.unissoft.interaction.entity.TimingTask;
import com.unissoft.interaction.service.TimingTaskService;

import io.swagger.annotations.ApiOperation;

/**
 * <p>
 *  前端控制器   定时
 * </p>
 *
 * @author root
 * @since 2022-05-06
 */
@RestController
@RequestMapping("/timing-task")
public class TimingTaskController {
	
	@Resource
    private TimingTaskService timingTaskService;
	
	
	
	/**
	 * 列表
	 */
	@PostMapping("/getPageList")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        IPage<TimingTask> page = timingTaskService.getPage(pageParam);
        return ResultView.success(page);
    }
	
	/**
	 * 新增/修改
	 */
	@SystemLog(operModul = "", operType = "定时", operDesc = "定时任务新增/修改")
    @PostMapping("/save")
    public ResultView save(@RequestBody TimingTask timingTask) {
        boolean save = timingTaskService.add(timingTask);
        if (save)
            return ResultView.success();
        else
            return ResultView.error();
    }
	
    /**
	 * 删除
	 * @param id
	 * @return
	 */
    @SystemLog(operModul = "", operType = "定时任务", operDesc = "定时任务删除")
    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/deleteById/{id}")
    public ResultView deleteById(@PathVariable Integer id) {
    	boolean flag = timingTaskService.removeById(id);
    	if (flag)
            return ResultView.success();
        else
            return ResultView.error();
    }
    
    
    /**
	 * 查看/编辑
	 * @param id
	 * @return
	 */
    @SystemLog(operModul = "", operType = "定时任务", operDesc = "定时任务查看/编辑")
    @ApiOperation(value = "根据id查看/编辑", notes = "")
    @DeleteMapping("/getById/{id}")
    public ResultView getById(@PathVariable Integer id) {
    	TimingTask timingTask = timingTaskService.getById(id);
    	return ResultView.success(timingTask);
    }
    
}
