package com.unissoft.interaction.service;

import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;


import com.unissoft.interaction.entity.TimingTask;
import com.unissoft.systemManage.model.OrgInfo;
import com.unissoft.systemManage.service.OrgInfoService;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

/**
 * @author wzx
 * @time 2018/6/9
 */
@Component("testTask")
public class TestTask extends AbstractTask {

    @Resource
    private TimingTaskService timingTaskService;
    
    @Resource
    private OrgInfoService orgInfoService;
    
    @Resource
    private TeDataService teDataService;
    
    @Resource
    private SquareService squareService;
    
    private Logger logger = LoggerFactory.getLogger(TestTask.class);

    @PostConstruct
    public void init() {
        this.cronExpression = "0/2 * * * * ? ";
    }

	@Override
	protected void executeInternal(JobExecutionContext context) {
		// TODO Auto-generated method stub
		logger.info("检测任务开始执行");
		
		String jobId = context.getTrigger().getJobKey().getName();
        TimingTask timingTask = timingTaskService.getById(jobId);
       // String orgId = timingTask.getOrgId();//单位id
        String houseId = timingTask.getHouseId();//仓房id
        String houseType = null;
        OrgInfo orgInfoHouse = null;
        if(!StringUtils.isEmpty(houseId)){
        	if(houseId.contains(",")){ //多个仓房
        		String[] houseIdArray = houseId.split(",");
                for (String cfId : houseIdArray) {
        			//根据仓房id获取仓房数据 判断是平房仓还是圆筒仓
                	orgInfoHouse = orgInfoService.getById(cfId);
                	 houseType = orgInfoHouse.getHouseType();
                	//20 筒仓  21 平房仓
                	if(houseType.equals("20")){
                		//执行筒仓的打点算法
                		String high = orgInfoHouse.getHigh();//仓房的高
                		String radius = orgInfoHouse.getRadius();//仓房的半径
                		Double diameter = Double.parseDouble(radius)*2;//直径
                		Double h = Double.parseDouble(high);
                		teDataService.scanTask(cfId,diameter,h);
                	}
                	if(houseType.equals("21")){
                		//平房仓的打点算法--------------
                		/*double houseWideOn = 0 ; 
                		double houseWideUnder = 0;
                		double houseLengthLeft = 0; 
                		double houseLengthRight = 0;
                		double houseHigh = 0;*/
                		double houseWideOn = orgInfoHouse.getHouseWideOn().doubleValue();
                		double houseWideUnder = orgInfoHouse.getHouseWideUnder().doubleValue();
                		double houseLengthLeft = orgInfoHouse.getHouseLengthLeft().doubleValue();
                		double houseLengthRight = orgInfoHouse.getHouseLengthRight().doubleValue();
                		double houseHigh = Double.valueOf(orgInfoHouse.getHigh());
                		squareService.scanSquareTask(cfId,houseWideOn, houseWideUnder, houseLengthLeft, houseLengthRight, houseHigh);
                	}
        		}
        	}else{//单个仓房
        		 orgInfoHouse = orgInfoService.getById(houseId);
           	     houseType = orgInfoHouse.getHouseType();
	           	 if(houseType.equals("20")){
	         		//执行筒仓的打点算法
	         		String high = orgInfoHouse.getHigh();//仓房的高
	         		String radius = orgInfoHouse.getRadius();//仓房的半径
	         		Double diameter = Double.parseDouble(radius)*2;//直径
	         		Double h = Double.parseDouble(high);
	         		teDataService.scanTask(houseId,diameter,h);
		         }
		         if(houseType.equals("21")){
		         	//平房仓的打点算法
		        	double houseWideOn = orgInfoHouse.getHouseWideOn().doubleValue();
             		double houseWideUnder = orgInfoHouse.getHouseWideUnder().doubleValue();
             		double houseLengthLeft = orgInfoHouse.getHouseLengthLeft().doubleValue();
             		double houseLengthRight = orgInfoHouse.getHouseLengthRight().doubleValue();
             		double houseHigh = Double.valueOf(orgInfoHouse.getHigh());
             		squareService.scanSquareTask(houseId,houseWideOn, houseWideUnder, houseLengthLeft, houseLengthRight, houseHigh);
             	
		         }
        	}
        	logger.info("检测任务结束");
        }
        
	}

}

