package com.unissoft.interaction.service.impl;

import com.unissoft.common.PageParam;
import com.unissoft.interaction.entity.TimingTask;
import com.unissoft.interaction.mapper.TimingTaskMapper;
import com.unissoft.interaction.service.QuartzManager;
import com.unissoft.interaction.service.TestTask;
import com.unissoft.interaction.service.TimingTaskService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.Date;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2022-05-06
 */
@Service
public class TimingTaskServiceImpl extends ServiceImpl<TimingTaskMapper, TimingTask> implements TimingTaskService {

	private TimingTaskMapper timingTaskMapper;
	@Autowired
	public void setTimingTaskService(TimingTaskMapper timingTaskMapper) {
        this.timingTaskMapper = timingTaskMapper;
    }
	
	@Resource
    private QuartzManager quartzManager;
	
	
	@Override
	public IPage<TimingTask> getPage(PageParam pageParam) {
		// TODO Auto-generated method stub
		Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();
        // 分页对象
        IPage<TimingTask> page = new Page<>(pageIndex, pageSize);
        // 查询条件
        String condition = pageParam.getCondition();
        QueryWrapper<TimingTask> ew = new QueryWrapper<>();
        if (!StringUtils.isEmpty(condition)) {
        	com.alibaba.fastjson.JSONObject jsStr = JSON.parseObject(condition);
    		String name = jsStr.getString("name");//名称
    		String tSwitch = jsStr.getString("tSwitch");//开关
    		if(!StringUtils.isEmpty(name)){
    			ew.like("name", name);
    		}
    		if(!StringUtils.isEmpty(tSwitch)){
    			ew.like("t_switch", tSwitch);
    		}
        }
        return timingTaskMapper.selectPage(page, ew);
	}

	@Override
	public boolean add(TimingTask timingTask) {
		// TODO Auto-generated method stub
		
		if (!StringUtils.isEmpty(timingTask.getId())) {
			//修改
            timingTask.setUpdateTime(new Date()); // 创建时间
            List<String> collect = timingTaskMapper.selectStartData().stream().map(t -> t.getId()).collect(Collectors.toList());
            timingTaskMapper.updateById(timingTask);
            
            if (timingTask.getTSwitch().equals("1") && !StringUtils.isEmpty(timingTask.getDetectionCron())) {
                if (collect.contains(timingTask.getId())) {
                    quartzManager.updateJob(timingTask.getId(), timingTask.getDetectionCron());
                } else {
                    quartzManager.addJob(timingTask.getId(), TestTask.class.getName(), timingTask.getDetectionCron());
                }
            }else {
                quartzManager.deleteJob(timingTask.getId());
            }
        } else {
        	//新增
        	UUID uuid = UUID.randomUUID();
            String code =  uuid.toString().replace("-", "");
            timingTask.setId(code);
            timingTask.setUpdateTime(new Date()); // 创建时间
            timingTaskMapper.insert(timingTask);
            //0是关闭，1是启动
            if (timingTask.getTSwitch().equals("1") && !StringUtils.isEmpty(timingTask.getDetectionCron())) {
                quartzManager.addJob(timingTask.getId(), TestTask.class.getName(), timingTask.getDetectionCron());
            }
        }
		
		return true;
	}

}
