package com.unissoft.mqConsumer.Manager;

import com.alibaba.fastjson.JSON;
import com.unissoft.basic.model.BasicEnum;
import com.unissoft.basic.service.BasicEnumService;
import com.unissoft.parameter.model.HardwareParameter;
import com.unissoft.parameter.service.HardwareParameterService;
import com.unissoft.systemManage.model.*;
import com.unissoft.systemManage.service.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * ClassName: HDManager
 * Package: com.unissoft.mqConsumer.Manager
 * Description: 接收处理业务数据
 *
 * @Author zlq
 * @Create 2023/3/6 15:08
 * @Version 1.0
 */
@Slf4j
@Component
public class ServiceManager {
    @Resource
    private RoleInfoService roleInfoService;
    @Resource
    private NBasicEdgeService nBasicEdgeService;
    @Autowired
    private BasicEnumService basicEnumService;

    @Autowired
    private HardwareParameterService hardwareParameterService;

    /**
     * 硬件参数
     * @param payload
     * @param type
     */
    public void HDManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                //获取硬件参数对象
                HardwareParameter hardwareParameter = JSON.parseObject(payload, HardwareParameter.class);
                //新增硬件数据
                    boolean save = hardwareParameterService.save(hardwareParameter);
                log.info("新增硬件信息{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                //获取硬件参数对象

                HardwareParameter hardwareParameter1 = JSON.parseObject(payload, HardwareParameter.class);
                    boolean b1 = hardwareParameterService.updateById(hardwareParameter1);
                log.info("修改硬件信息{},是否成功：{}",payload,b1);
                break;
            case "DELETE":
                    boolean b2 = hardwareParameterService.removeById(payload);
                log.info("删除硬件id{},是否成功：{}",payload,b2);
                break;
        }
    }

    /**
     * 字典
     * @param payload
     * @param type
     */
    public void BasicEnumManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                BasicEnum basicEnum = JSON.parseObject(payload, BasicEnum.class);
                boolean save = basicEnumService.save(basicEnum);
                log.info("新增字典{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                BasicEnum basicEnum1 = JSON.parseObject(payload, BasicEnum.class);
                boolean b = basicEnumService.updateById(basicEnum1);
                log.info("修改字典信息{},是否成功：{}",payload,b);
                break;
        }
    }

    /**
     *打点的数据查询表
     * @param payload
     * @param type
     */
    public void NBasicEdgeManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                NBasicEdge nBasicEdge = JSON.parseObject(payload, NBasicEdge.class);
                boolean save = nBasicEdgeService.save(nBasicEdge);
                log.info("新增打点的数据信息{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                NBasicEdge nBasicEdge1 = JSON.parseObject(payload, NBasicEdge.class);
                boolean b = nBasicEdgeService.updateById(nBasicEdge1);
                log.info("修改打点的数据信息{},是否成功：{}",payload,b);
                break;
        }
    }


    /**
     *用户角色消息
     * @param payload
     * @param type
     */
    public void RoleInfoManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                RoleInfo roleInfo = JSON.parseObject(payload, RoleInfo.class);
                boolean save = roleInfoService.save(roleInfo);
                log.info("新增角色消息{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                RoleInfo roleInfo1 = JSON.parseObject(payload, RoleInfo.class);
                boolean b = roleInfoService.updateById(roleInfo1);
                log.info("修改角色消息{},是否成功：{}",payload,b);
                break;
            case "DELETE":
                boolean b2 = roleInfoService.removeById(payload);
                log.info("删除角色id{},是否成功：{}",payload,b2);
                break;
        }
    }

    @Resource
    private UserInfoService userInfoService;

    /**
     *用户消息
     * @param payload
     * @param type
     */
    public void UserInfoManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                UserInfo userInfo = JSON.parseObject(payload, UserInfo.class);
                boolean save = userInfoService.save(userInfo);
                log.info("新增用户{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                UserInfo userInfo1 = JSON.parseObject(payload, UserInfo.class);
                boolean b = userInfoService.updateById(userInfo1);
                log.info("修改用户{},是否成功：{}",payload,b);
                break;
            case "DELETE":
                boolean b2 = userInfoService.removeById(payload);
                log.info("删除用户{},是否成功：{}",payload,b2);
                break;
        }
    }
    @Resource
    private OrgInfoService orgInfoService;
    /**
     *组织机构消息
     * @param payload
     * @param type
     */
    public void OrgInfoManager(String payload,String type){
        //对不同的业务操作进行处理：SAVE,UPDATE,DELETE;
        switch (type){
            case "SAVE":
                OrgInfo orgInfo = JSON.parseObject(payload, OrgInfo.class);
                boolean save = orgInfoService.save(orgInfo);
                log.info("新增组织机构{},是否成功：{}",payload,save);
                break;
            case "UPDATE":
                OrgInfo orgInfo1 = JSON.parseObject(payload, OrgInfo.class);
                boolean b = orgInfoService.updateById(orgInfo1);
                log.info("修改组织机构信息{},是否成功：{}",payload,b);
                break;
            case "DELETE":
                boolean b2 = orgInfoService.removeById(payload);
                log.info("删除组织机构id{},是否成功：{}",payload,b2);
                break;
        }
    }
}
