package com.unissoft.parameter.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.*;
import com.unissoft.mqProducer.Producer;
import com.unissoft.parameter.model.HardwareParameter;
import com.unissoft.parameter.service.HardwareParameterService;

import io.swagger.annotations.ApiOperation;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-10-19
 */
@RestController
@RequestMapping("/hdParemeter")
public class HardwareParameterController {

    private HardwareParameterService hdService;

    @Autowired
    private Producer producer;

    @Autowired
    public void setHardwareParameterController(HardwareParameterService hdService) {
        this.hdService = hdService;
    }

    /**
     * 分页查询列表
     * @param pageParam
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "硬件参数", operDesc = "查询分页硬件参数")
    @PostMapping("/getPage")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        IPage<HardwareParameter> page = hdService.getPage(pageParam);
        return ResultView.success(page);
    }
    
   

    /**
     * 新增
     * @param hdParameter
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "硬件参数", operDesc = "硬件参数新增")
    @PostMapping("/save")
    public ResultView saveUser(@RequestBody HardwareParameter hdParameter) {
    	hdParameter.setCreateTime(new Date());
        boolean save = hdService.save(hdParameter);
        if (save) {
            producer.send(hdParameter, MessageEnum.SAVE, ServiceEnum.HD_PARAMETER);
            return ResultView.success();
        }else
            return ResultView.error();
    }

    /**
     * 修改
     * @param hdParameter
     * @return
     */
    @SystemLog(operModul = "参数设置", operType = "硬件参数", operDesc = "硬件参数修改")
    @PostMapping("/update")
    public ResultView updateUser(@RequestBody HardwareParameter hdParameter) {
        boolean b = hdService.updateById(hdParameter);
        if (b) {
            producer.send(hdParameter, MessageEnum.UPDATE,ServiceEnum.HD_PARAMETER);
            return ResultView.success();
        }else
            return ResultView.error();
    }
    
    
    /**
	 * 删除
	 * @param id
	 * @return
	 */
    @SystemLog(operModul = "参数设置", operType = "硬件参数", operDesc = "硬件参数删除")
    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/deleteById/{id}")
    public ResultView deleteById(@PathVariable String id) {
    	boolean b = hdService.removeById(id);
        if (b) {
            producer.send(id, MessageEnum.DELETE,ServiceEnum.HD_PARAMETER);
            return ResultView.success();
        }else
            return ResultView.error();
    }
    
}
