package com.unissoft.parameter.service.impl;

import com.unissoft.parameter.model.HardwareParameter;
import com.unissoft.common.PageParam;
import com.unissoft.parameter.mapper.HardwareParameterMapper;
import com.unissoft.parameter.service.HardwareParameterService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-19
 */
@Service
public class HardwareParameterServiceImpl extends ServiceImpl<HardwareParameterMapper, HardwareParameter> implements HardwareParameterService {

	
	private HardwareParameterMapper hdMapper;
	@Autowired
	public void setHardwareParameterService(HardwareParameterMapper hdMapper) {
        this.hdMapper = hdMapper;
    }
	@Override
	public IPage<HardwareParameter> getPage(PageParam pageParam) {
		// TODO Auto-generated method stub
		// 分页条件
        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();
        // 分页对象
        IPage<HardwareParameter> page = new Page<>(pageIndex, pageSize);
        // 查询条件
        String condition = pageParam.getCondition();
        QueryWrapper<HardwareParameter> ew = new QueryWrapper<>();
        if (!StringUtils.isEmpty(condition)) {
        	com.alibaba.fastjson.JSONObject jsStr = JSON.parseObject(condition);
    		String deviceName = jsStr.getString("deviceName");//设备名称
    		Integer houseId = jsStr.getInteger("houseId");
    		if(!StringUtils.isEmpty(houseId.toString())){
    			ew.eq("house_id", houseId);
    		}
    		if (!StringUtils.isEmpty(deviceName)) {
                ew.like("device_name", deviceName);
            }
        }
        return hdMapper.selectPage(page, ew);
	}

	@Override
	public int deleteHarParamer(String id) {
		int i = hdMapper.deleteById(id);

		return i;
	}


}
