package com.unissoft.systemManage.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.PageParam;
import com.unissoft.common.ResultView;
import com.unissoft.common.SystemLog;
import com.unissoft.systemManage.model.BasicPoliceLog;
import com.unissoft.systemManage.model.BasicRulePolice;
import com.unissoft.systemManage.model.OrgInfo;
import com.unissoft.systemManage.service.BasicPoliceLogService;
import com.unissoft.systemManage.service.BasicRulePoliceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@Api(tags = "报警记录")
@RestController
@RequestMapping("/basic-police-log")
public class BasicPoliceLogController {

    private BasicPoliceLogService basicPoliceLogService;

    @Autowired
    public void setBasicPoliceLogController(BasicPoliceLogService basicPoliceLogService) {
        this.basicPoliceLogService = basicPoliceLogService;
    }

    @ApiOperation(value = "报警记录列表")
    @PostMapping("/getPoliceLogPage")
    public ResultView getPoliceLogPage(@RequestBody PageParam pageParam) {
        IPage<BasicPoliceLog> page = basicPoliceLogService.getPoliceLogPage(pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据仓房id查询报警列表", notes = "")
    @GetMapping("/basic/getPoliceLogByHouseId/{houseId}")
    public ResultView getPoliceLogByHouseId(@PathVariable String houseId) {
        List<BasicPoliceLog> listPoliceLog = basicPoliceLogService.getTreeList(houseId);
        return ResultView.success(listPoliceLog);
    }


}
