package com.unissoft.systemManage.controller;


import com.unissoft.common.ResultView;
import com.unissoft.systemManage.model.BasicRulePolice;
import com.unissoft.systemManage.model.NBasicEdge;
import com.unissoft.systemManage.service.BasicRulePoliceService;
import com.unissoft.systemManage.service.NBasicEdgeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@Api(tags = "报警规则")
@RestController
@RequestMapping("/basic-rule-police")
public class BasicRulePoliceController {


    private BasicRulePoliceService basicRulePoliceService;

    @Autowired
    public void setBasicRulePoliceController(BasicRulePoliceService basicRulePoliceService) {
        this.basicRulePoliceService = basicRulePoliceService;
    }

    @ApiOperation(value = "根据仓房id查询", notes = "")
    @GetMapping("/basic/getRulePoliceByHouseId/{houseId}")
    public ResultView getRulePoliceByHouseId(@PathVariable String houseId) {
        List<BasicRulePolice> listRulePolice = basicRulePoliceService.getTreeList(houseId);
        return ResultView.success(listRulePolice);
    }

    @ApiOperation(value = "新增报警规则", notes = "")
    @PostMapping("/basic/saveBasicRulePolice")
    public ResultView saveBasicRulePolice(@RequestBody BasicRulePolice basicRulePolice) {
        boolean save = basicRulePoliceService.save(basicRulePolice);
        if (save)
            return ResultView.success();
        else
            return ResultView.error();
    }

    @ApiOperation(value = "修改扫描规则", notes = "")
    @PostMapping("/basic/updateBasicRulePolice")
    public ResultView updateBasicRulePolice(@RequestBody BasicRulePolice basicRulePolice) {
        boolean b = basicRulePoliceService.updateById(basicRulePolice);
        if (b)
            return ResultView.success();
        else
            return ResultView.error();
    }

}
