package com.unissoft.systemManage.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.*;
import com.unissoft.mqProducer.Producer;
import com.unissoft.systemManage.model.LogOperation;
import com.unissoft.systemManage.model.NBasicEdge;
import com.unissoft.systemManage.model.RoleInfo;
import com.unissoft.systemManage.model.SyncV2xyz;
import com.unissoft.systemManage.service.NBasicEdgeService;
import com.unissoft.systemManage.service.RoleInfoService;

import ch.qos.logback.classic.Logger;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.net.URLDecoder;
import java.text.ParseException;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@Api(tags = "扫描规则--体积 重量")
@RestController
@RequestMapping("/n-basic-edge")
public class NBasicEdgeController {
    @Autowired
    private Producer producer;

    private NBasicEdgeService nBasicEdgeService;

    @Autowired
    public void setNBasicEdgeController(NBasicEdgeService nBasicEdgeService) {
        this.nBasicEdgeService = nBasicEdgeService;
    }

    
    /**
     * 设备回传的数据(该接口暂时不用)
     * @param syncV2xyz
     * @return
     * @throws Exception
     */
    @PostMapping(value ="/getEdgeData")
    public String getEdgeData(@RequestBody SyncV2xyz syncV2xyz) throws Exception{
    	/*SyncV2xyz syncV2xyz = new SyncV2xyz();
    	syncV2xyz.setStartTime(new Date());
    	syncV2xyz.setVolume(21.28);
    	syncV2xyz.setXyz("%5B%5B1%2C1%2C0.61%5D%2C%5B1%2C2%2C0.61%5D%2C%5B-1%2C2%2C0.61%5D%2C%5B1%2C1%2C0.61%5D%5D%5B%5B1%2C1%2C0.37%5D%2C%5B1%2C2%2C0.37%5D%2C%5B-1%2C2%2C0.37%5D%2C%5B1%2C1%2C0.37%5D%2C%5B1%2C1%2C0.37%5D%2C%5B1%2C2%2C0.37%5D%2C%5B-1%2C2%2C0.37%5D%2C%5B1%2C1%2C0.37%5D%5D");
    	*/
    	nBasicEdgeService.saveEdgeData(syncV2xyz);
		return "202";
    }
    
    @ApiOperation(value = "根据仓房id查询分页", notes = "")
    @PostMapping("/basic/getCornByHouseId")
    public ResultView getCornByHouseId(@RequestBody PageParam pageParam) {
        IPage<NBasicEdge> listNbasic = nBasicEdgeService.getTreeList(pageParam);
        return ResultView.success(listNbasic);
    }

    @ApiOperation(value = "新增扫描规则", notes = "")
    @PostMapping("/basic/saveNBasicEdge")
    public ResultView saveRoleInfo(@RequestBody NBasicEdge nBasicEdge) {
        boolean save = nBasicEdgeService.save(nBasicEdge);
        if (save) {
            producer.send(nBasicEdge, MessageEnum.SAVE, ServiceEnum.NBASIC_EDGE);
            return ResultView.success();
        }else {
            return ResultView.error();
        }
    }

    @ApiOperation(value = "修改扫描规则", notes = "")
    @PostMapping("/basic/updateNBasicEdge")
    public ResultView updateRoleInfo(@RequestBody NBasicEdge nBasicEdge) {
        boolean b = nBasicEdgeService.updateById(nBasicEdge);
        if (b) {
            producer.send(nBasicEdge, MessageEnum.UPDATE, ServiceEnum.NBASIC_EDGE);
            return ResultView.success();
        }else {
            return ResultView.error();
        }
    }
    
    
    
    @ApiOperation(value = "根据库id查询分页", notes = "")
    @PostMapping("/basic/getCornByOrgId")
    public ResultView getCornByOrgId(@RequestBody PageParam pageParam) {
        List<NBasicEdge> listNbasic = nBasicEdgeService.getListByOrgId(pageParam);
        return ResultView.success(listNbasic);
    }
    
    
    
    @ApiOperation(value = "手动新增扫描规则", notes = "")
    @PostMapping("/basic/manualSaveNBasicEdge")
    public ResultView manualSaveNBasicEdge(@RequestParm("nBasicEdgeStr") String nBasicEdgeStr) throws ParseException{
        int save = nBasicEdgeService.manualSaveNBasicEdge(nBasicEdgeStr);
        if (save>0)
            return ResultView.success();
        else
            return ResultView.error();
    }
}
