package com.unissoft.systemManage.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.common.*;
import com.unissoft.systemManage.model.OrgAnnouncement;
import com.unissoft.systemManage.model.UserInfo;
import com.unissoft.systemManage.service.OrgAnnouncementService;
import com.unissoft.systemManage.service.UserInfoService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 公告管理
 * @author mengy
 * @since 2021-10-20
 */
@RestController
@RequestMapping("/orgAnnouncement")
public class OrgAnnouncementController {

    private OrgAnnouncementService orgAnnouncementService;
    @Autowired
    public void setOrgAnnouncementController(OrgAnnouncementService orgAnnouncementService) {
        this.orgAnnouncementService = orgAnnouncementService;
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getOrgAnnouncementById/{id}")
    public ResultView getOrgAnnouncementById(@PathVariable String id) {
        OrgAnnouncement announcement = orgAnnouncementService.getById(id);
        return ResultView.success(announcement);
    }

    @ApiOperation(value = "首页公告", notes = "6条记录")
    @GetMapping("/authority/getOrgAnnouncementIndex")
    public ResultView getOrgAnnouncementIndex() {
        return ResultView.success(orgAnnouncementService.getAnnouncementtList());
    }


    @PostMapping("/authority/getOrgAnnouncementPage")
    public ResultView getOrgAnnouncementPage(@RequestBody PageParam pageParam, String createTimeStart, String createTimeEnd) {
        IPage<OrgAnnouncement> page = orgAnnouncementService.getOrgAnnouncementPage(pageParam, createTimeStart, createTimeEnd);
        return ResultView.success(page);
    }

    @SystemLog(operModul = "公告管理", operType = "新增公告信息", operDesc = "新增公告信息")
    @PostMapping("/authority/save")
    public ResultView saveUser(@RequestBody OrgAnnouncement announcement) {
        boolean save = orgAnnouncementService.save(announcement);
        if (save) {
            return ResultView.success();
        } else{
            return ResultView.error();
        }
    }
    @SystemLog(operModul = "公告管理", operType = "修改公告信息", operDesc = "根据id修改公告信息")
    @PostMapping("/authority/update")
    public ResultView updateUser(@RequestBody OrgAnnouncement announcement) {
        boolean b = orgAnnouncementService.updateById(announcement);
        if (b) {
            return ResultView.success();
        } else{
            return ResultView.error();
        }

    }
    @SystemLog(operModul = "公告管理", operType = "删除公告信息", operDesc = "通过id删除公告信息")
    @GetMapping("/authority/deleteById/{id}")
    public ResultView getByIdForUserDelete(@PathVariable String id) {
        if (orgAnnouncementService.removeById(id)) {
            return ResultView.success();
        }
        return ResultView.error(MyConstant.ID_NULL);
    }

}
