package com.unissoft.systemManage.controller;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import com.unissoft.common.ResultView;
import com.unissoft.systemManage.model.PointData;
import com.unissoft.systemManage.service.PointDataService;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2021-12-06
 */
@RestController
@RequestMapping("/point-data")
public class PointDataController {
	
	private PointDataService pointDataService;

    @Autowired
    public void setPointDataController(PointDataService pointDataService) {
        this.pointDataService = pointDataService;
    }
    
	@GetMapping("/getPoints/{houseId}")
    public ResultView getById(@PathVariable Integer houseId) {
		
		Map<String, Object> parm_map = new HashMap<>();
		if(!StringUtils.isEmpty(houseId.toString())){
			parm_map.put("house_id", houseId);
		}
		
		List<PointData> pointList = pointDataService.listByMap(parm_map);
		if(pointList.size()>0){
			return ResultView.success(pointList.get(pointList.size()-1));
		}else{
			return ResultView.success();
		}
        
    }

}
