package com.unissoft.systemManage.controller;


import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import com.unissoft.common.PageParam;
import com.unissoft.common.ResultView;
import com.unissoft.common.SystemLog;
import com.unissoft.systemManage.model.QuantityStatistics;
import com.unissoft.systemManage.service.QuantityStatisticsService;

import io.swagger.annotations.ApiOperation;

/**
 * <p>
 *  前端控制器-----首页
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@RestController
@RequestMapping("/quantity-statistics")
public class QuantityStatisticsController {

	private QuantityStatisticsService quantityStatisticsService;
    @Autowired
    public void setQuantityStatisticsController(QuantityStatisticsService quantityStatisticsService) {
        this.quantityStatisticsService = quantityStatisticsService;
    }
    
	
	/**
	 * 获取数据
	 * @return
	 * @throws Exception 
	 */
    @SystemLog(operModul = "首页", operType = "出入库量统计", operDesc = "出入库量统计")
    @PostMapping("/getData")
	@ApiOperation(value="首页出入库量统计", notes="首页出入库量统计")
	public ResultView getData(@RequestBody PageParam pageParam) {
		List<QuantityStatistics> list = quantityStatisticsService.getData(pageParam);
		return ResultView.success(list);
	}
    
    
    //----------------------------新------------------------------------
    /**
     * 近一周粮食数量变化
     */
    @SystemLog(operModul = "首页", operType = "近一周粮食数量变化", operDesc = "近一周粮食数量变化")
    @PostMapping("/getDataChange")
	@ApiOperation(value="近一周粮食数量变化", notes="近一周粮食数量变化")
	public ResultView getDataChange(@RequestBody PageParam pageParam) {
		Map<String, Object> map = quantityStatisticsService.getDataChange(pageParam);
		return ResultView.success(map);
	}
    
    
    /**
     * 首页
     * 当天出入库量 总仓容 已用 剩余
     */
    @SystemLog(operModul = "首页", operType = "出入库量", operDesc = "出入库量")
    @PostMapping("/getOutInNumber")
	@ApiOperation(value="出入库量", notes="出入库量")
	public ResultView getOutInNumber(@RequestBody PageParam pageParam) {
		Map<String, Object> map = quantityStatisticsService.getOutInNumber(pageParam);
		return ResultView.success(map);
	}
    
    
    /**
     * 库区图
     */
    @SystemLog(operModul = "首页", operType = "库区图", operDesc = "库区图")
    @PostMapping("/getHouseMessage")
	@ApiOperation(value="库区图", notes="库区图")
	public ResultView getHouseMessage(@RequestBody PageParam pageParam) {
		Map<String, Object> map = quantityStatisticsService.getHouseMessage(pageParam);
		return ResultView.success(map);
	}
    
    
}
