package com.unissoft.systemManage.model;

import com.baomidou.mybatisplus.annotation.TableName;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 操作日志表
 * </p>
 *
 * @author root
 * @since 2021-10-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("log_operation")
@ApiModel(value="LogOperation对象", description="操作日志表")
public class LogOperation implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @TableId("oper_id")
    private String operId;

    @ApiModelProperty(value = "用户ID")
    @TableField("user_id")
    private String userId;

    @ApiModelProperty(value = "操作用户名")
    @TableField("user_name")
    private String userName;

    @ApiModelProperty(value = "组织机构编码")
    @TableField("org_id")
    private Integer orgId;

    @ApiModelProperty(value = "操作时间")
    @TableField("oper_time")
    private Date operTime;

    @ApiModelProperty(value = "动作(操作类型)")
    @TableField("oper_type")
    private String operType;

    @ApiModelProperty(value = "功能模块(操作功能模块)")
    @TableField("oper_modul")
    private String operModul;

    @ApiModelProperty(value = "操作数据描述")
    @TableField("oper_desc")
    private String operDesc;

    @ApiModelProperty(value = "登录IP")
    @TableField("oper_ip")
    private String operIp;

    @ApiModelProperty(value = "操作方法")
    @TableField("oper_method")
    private String operMethod;

    @ApiModelProperty(value = "请求url")
    @TableField("oper_uri")
    private String operUri;

    @ApiModelProperty(value = "操作版本号")
    @TableField("oper_version")
    private String operVersion;

    @ApiModelProperty(value = "请求参数")
    @TableField("oper_request_param")
    private String operRequestParam;

    @ApiModelProperty(value = "返回参数")
    @TableField("oper_respons_param")
    private String operResponsParam;


}
