package com.unissoft.systemManage.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.math.BigDecimal;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 组织机构和仓房表
 * </p>
 *
 * @author root
 * @since 2021-10-20
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("org_info")
@ApiModel(value="OrgInfo对象", description="组织机构和仓房表")
public class OrgInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键id")
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    @ApiModelProperty(value = "组织机构名称(仓房名称)")
    @TableField("org_name")
    private String orgName;

    @ApiModelProperty(value = "仓房类型名称")
    @TableField("store_type_name")
    private String storeTypeName;

    @ApiModelProperty(value = "仓库类型编码")
    @TableField("store_type_code")
    private Integer storeTypeCode;

    @ApiModelProperty(value = "机构状态(0:停用,1启用)")
    @TableField("org_state")
    private String orgState;

    @ApiModelProperty(value = "父级ID(默认值为0,0表示顶级机构)")
    @TableField("parent_id")
    private Long parentId;

    @ApiModelProperty(value = "创建时间")
    @TableField("build_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date buildTime;

    @ApiModelProperty(value = "保管员")
    @TableField("keeper")
    private Integer keeper;

    @ApiModelProperty(value = "联系放肆")
    @TableField("lxfs")
    private String lxfs;

    @ApiModelProperty(value = "仓房状态(1:空仓,2:入库,3:封仓,4:出库)")
    @TableField("cf_status")
    private Integer cfStatus;

    @ApiModelProperty(value = "装粮线高度")
    @TableField("zlxgd")
    private BigDecimal zlxgd;

    @ApiModelProperty(value = "设计仓容")
    @TableField("sjcr")
    private BigDecimal sjcr;

    @ApiModelProperty(value = "长")
    @TableField("chang")
    private BigDecimal chang;

    @ApiModelProperty(value = "宽")
    @TableField("kuan")
    private BigDecimal kuan;

    @ApiModelProperty(value = "仓内体积")
    @TableField("cntj")
    private BigDecimal cntj;

    @ApiModelProperty(value = "最近一次修改时间")
    @TableField("last_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date lastTime;
    
    @ApiModelProperty(value = "仓房类型")
    @TableField("house_type")
    private String houseType;
    
    @ApiModelProperty(value = "高")
    @TableField("high")
    private String high;
    
    @ApiModelProperty(value = "半径")
    @TableField("radius")
    private String radius;
    
    
    
    @ApiModelProperty(value = "平房仓中宽的上半部分")
    @TableField("house_wide_on")
    private BigDecimal houseWideOn;
    
    @ApiModelProperty(value = "平房仓中宽的下半部分")
    @TableField("house_wide_under")
    private BigDecimal houseWideUnder;
    
    @ApiModelProperty(value = "平房仓中长的左半部分")
    @TableField("house_length_left")
    private BigDecimal houseLengthLeft;
    
    @ApiModelProperty(value = "平房仓中长的右半部分")
    @TableField("house_length_right")
    private BigDecimal houseLengthRight;
    
    
    /**
     * 业务字段
     */
    @TableField(exist = false)
	private String pzName; //品种名称
    
    @TableField(exist = false)
	private String lsNumber; //当前粮食数量
    
    
    @TableField(exist = false)
	private String ssfk;
    
    @TableField(exist = false)
	private String pz;
    
    @TableField(exist = false)
	private String dj;
    
    @TableField(exist = false)
	private String cnlsrz;
}
