package com.unissoft.systemManage.model;

import com.baomidou.mybatisplus.annotation.TableName;

import java.math.BigDecimal;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 
 * </p>
 *
 * @author root
 * @since 2021-10-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("storehouse_clxx")
@ApiModel(value="StorehouseClxx对象", description="")
public class StorehouseClxx implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键ID")
    @TableId("id")
    private String id;

    @ApiModelProperty(value = "关联org_info的主键ID")
    @TableField("main_id")
    private Long mainId;

    @ApiModelProperty(value = "组织机构ID")
    @TableField("org_id")
    private Integer orgId;

    @ApiModelProperty(value = "品种")
    @TableField("pz")
    private String pz;

    @ApiModelProperty(value = "仓容粮食容量")
    @TableField("crlsrl")
    private BigDecimal crlsrl;

    @ApiModelProperty(value = "等级")
    @TableField("dj")
    private String dj;

    @ApiModelProperty(value = "首次入库时间")
    @TableField("scrksj")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date scrksj;

    @ApiModelProperty(value = "数据保存时间")
    @TableField("input_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date inputTime;
    
    
    //业务字段
    @TableField(exist = false)
	private String cfName; //仓房名称
    
    @TableField(exist = false)
	private String pzName; //品种名称
    
    @TableField(exist = false)
	private String lsNumber; //当前粮食数量
    
    @TableField(exist = false)
	private String changeRatio; //比昨天增长或者减少的比例
    
    @TableField(exist = false)
	private String changeNumber; //比昨天增长或者减少的数量

}
