package com.unissoft.systemManage.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.common.PageParam;
import com.unissoft.systemManage.model.OrgInfo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.unissoft.systemManage.model.OrgInfoChildren;
import com.unissoft.systemManage.model.StorehouseClxx;
import com.unissoft.systemManage.model.UserInfo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 组织机构和仓房表 服务类
 * </p>
 *
 * @author root
 * @since 2021-10-20
 */
public interface OrgInfoService extends IService<OrgInfo> {

    List<OrgInfoChildren> getTreeList(String orgName);

    /**
     * 组织机构分页查询
     * @param pageParam
     * @return
     */
    IPage<OrgInfo> getOrgInfoPage(PageParam pageParam);

    /**
     * 更新仓房信息
     * @param storehouse 仓房信息
     * @param clxx 仓房储粮信息
     * @return
     */
    boolean updateStorehouse(String storehouse) throws Exception;

    List<OrgInfo> getList(OrgInfo orgInfo);

    /**
     * 仓房列表分页查询
     * @param pageParam
     * @return
     */
    Page<List<Map<String, Object>>> getStorehousePage(PageParam pageParam);

    List<OrgInfo> getOrgMap(String orgId);
}
