package com.unissoft.systemManage.service.impl;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.common.PageParam;
import com.unissoft.systemManage.mapper.NBasicEdgeMapper;
import com.unissoft.systemManage.model.BasicPoliceLog;
import com.unissoft.systemManage.mapper.BasicPoliceLogMapper;
import com.unissoft.systemManage.model.NBasicEdge;
import com.unissoft.systemManage.model.OrgInfo;
import com.unissoft.systemManage.model.UserInfo;
import com.unissoft.systemManage.service.BasicPoliceLogService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@Service
public class BasicPoliceLogServiceImpl extends ServiceImpl<BasicPoliceLogMapper, BasicPoliceLog> implements BasicPoliceLogService {

    @Resource
    BasicPoliceLogMapper basicPoliceLogMapper;

    @Override
    public IPage<BasicPoliceLog> getPoliceLogPage(PageParam pageParam) {
        // 分页条件
        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();

        // 查询条件
        String condition = pageParam.getCondition();
        QueryWrapper<BasicPoliceLog> queryWrapper = new QueryWrapper<>();
        if (!StringUtils.isEmpty(condition)) {
            // 查询条件转Java对象
            BasicPoliceLog basicPoliceLog = JSON.parseObject(condition, BasicPoliceLog.class);
            // 获取查询条件
            String orgId = basicPoliceLog.getOperId();
            String userName = basicPoliceLog.getOperName();
            if (!StringUtils.isEmpty(orgId))
                queryWrapper.eq("oper_id", orgId);
            if (!StringUtils.isEmpty(userName))
                queryWrapper.like("oper_name", userName);
        }
        queryWrapper.orderByDesc("create_time");
        // 分页对象
        IPage<BasicPoliceLog> page = new Page<>(pageIndex, pageSize);
        return basicPoliceLogMapper.selectPage(page, queryWrapper);
    }



    @Override
    public List<BasicPoliceLog> getTreeList(String houseId) {
        QueryWrapper<BasicPoliceLog> queryWrapper = new QueryWrapper<>();

        List<BasicPoliceLog> nBasicEdgeList = null;
        // 没有搜索条件时
        if (!StringUtils.isEmpty(houseId)) {
            queryWrapper.eq("house_id", houseId);
            nBasicEdgeList = basicPoliceLogMapper.selectList(queryWrapper);
        }
        return nBasicEdgeList;
    }
}
