package com.unissoft.systemManage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.unissoft.systemManage.mapper.NBasicEdgeMapper;
import com.unissoft.systemManage.model.BasicRulePolice;
import com.unissoft.systemManage.mapper.BasicRulePoliceMapper;
import com.unissoft.systemManage.model.NBasicEdge;
import com.unissoft.systemManage.service.BasicRulePoliceService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-22
 */
@Service
public class BasicRulePoliceServiceImpl extends ServiceImpl<BasicRulePoliceMapper, BasicRulePolice> implements BasicRulePoliceService {

    @Resource
    private BasicRulePoliceMapper basicRulePoliceMapper;

    @Override
    public List<BasicRulePolice> getTreeList(String houseId) {
        QueryWrapper<BasicRulePolice> queryWrapper = new QueryWrapper<>();

        List<BasicRulePolice> basicRulePoliceList = null;
        // 没有搜索条件时
        if (!StringUtils.isEmpty(houseId)) {
            queryWrapper.eq("house_id", houseId);
            basicRulePoliceList = basicRulePoliceMapper.selectList(queryWrapper);
        }
        return basicRulePoliceList;
    }
}
