package com.unissoft.systemManage.service.impl;


import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.common.PageParam;
import com.unissoft.systemManage.mapper.OrgAnnouncementMapper;
import com.unissoft.systemManage.mapper.UserInfoMapper;
import com.unissoft.systemManage.model.OrgAnnouncement;
import com.unissoft.systemManage.model.UserInfo;
import com.unissoft.systemManage.service.OrgAnnouncementService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-20
 */
@Service
public class OrgAnnouncementServiceImpl extends ServiceImpl<OrgAnnouncementMapper, OrgAnnouncement> implements OrgAnnouncementService {

    private OrgAnnouncementMapper orgAnnouncementMapper;
    @Autowired
    public void setOrgAnnouncementMapper(OrgAnnouncementMapper orgAnnouncementMapper) {
        this.orgAnnouncementMapper = orgAnnouncementMapper;
    }

    @Override
    public List<OrgAnnouncement> getAnnouncementtList() {
        return orgAnnouncementMapper.selectAnnouncementtListBylimit();
    }

    @Override
    public IPage<OrgAnnouncement> getOrgAnnouncementPage(PageParam pageParam,String createTimeStart,String createTimeEnd) {
        // 分页条件
        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();
        // 分页对象
        IPage<OrgAnnouncement> page = new Page<>(pageIndex, pageSize);
        // 查询条件
        String condition = pageParam.getCondition();
        QueryWrapper<OrgAnnouncement> queryWrapper = new QueryWrapper<>();
        if (!StringUtils.isEmpty(condition)) {
            // 查询条件转Java对象
            OrgAnnouncement orgAnnouncement = JSON.parseObject(condition, OrgAnnouncement.class);
            // 获取查询条件
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            try {
                if(createTimeStart!=null && createTimeStart!=""){
                    createTimeStart = createTimeStart+" "+"00:00:00";
                    Date startDate = simpleDateFormat.parse(createTimeStart);
                    queryWrapper.ge("publlisher_time",startDate);
                }
                if(createTimeEnd!=null && createTimeEnd!=""){
                    createTimeEnd = createTimeEnd +" "+ "23:59:59";
                    Date endtDate = simpleDateFormat.parse(createTimeEnd);
                    queryWrapper.le("publlisher_time",endtDate);
                }

            } catch (ParseException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }

        }
        return orgAnnouncementMapper.selectPage(page,queryWrapper);

    }
}
