package com.unissoft.systemManage.service.impl;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.common.PageParam;
import com.unissoft.systemManage.model.RoleInfo;
import com.unissoft.systemManage.mapper.RoleInfoMapper;
import com.unissoft.systemManage.service.RoleInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * <p>
 * 用户角色表 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-20
 */
@Service
public class RoleInfoServiceImpl extends ServiceImpl<RoleInfoMapper, RoleInfo> implements RoleInfoService {

    private RoleInfoMapper roleInfoMapper;
    @Autowired
    public void setRoleInfoService(RoleInfoMapper roleInfoMapper) {
        this.roleInfoMapper = roleInfoMapper;
    }

    @Override
    public IPage<RoleInfo> getRoleInfoPage(PageParam pageParam) {
        // 分页条件
        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();
        // 查询条件
        String condition = pageParam.getCondition();
        QueryWrapper<RoleInfo> queryWrapper = new QueryWrapper<>();
        if (!StringUtils.isEmpty(condition)) {
            // 查询条件转Java对象
            RoleInfo roleInfo = JSON.parseObject(condition, RoleInfo.class);
            // 获取查询条件
            Long orgId = roleInfo.getOrgId();
            String roleName = roleInfo.getRoleName();
            if (!StringUtils.isEmpty(orgId))
                queryWrapper.eq("org_id", roleInfo.getOrgId());
            if (!StringUtils.isEmpty(roleName))
                queryWrapper.like("role_name", roleName);
        }
        queryWrapper.orderByDesc("bulid_time");
        // 分页对象
        IPage<RoleInfo> page = new Page<>(pageIndex, pageSize);
        return roleInfoMapper.selectPage(page, queryWrapper);
    }
}
