package com.unissoft.systemManage.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.unissoft.systemManage.mapper.OrgInfoMapper;
import com.unissoft.systemManage.model.OrgInfo;
import com.unissoft.systemManage.model.StorehouseClxx;
import com.unissoft.systemManage.mapper.StorehouseClxxMapper;
import com.unissoft.systemManage.service.StorehouseClxxService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2021-10-21
 */
@Service
public class StorehouseClxxServiceImpl extends ServiceImpl<StorehouseClxxMapper, StorehouseClxx> implements StorehouseClxxService {

    @Autowired
    private StorehouseClxxMapper storehouseClxxMapper;
    @Autowired
    private OrgInfoMapper orgInfoMapper;

    @Override
    public boolean deleteStorehouse(Integer id) {

        boolean flag = false;

        Map<String, Object> map = new HashMap<>();
        map.put("main_id", id);
        storehouseClxxMapper.deleteByMap(map);
        orgInfoMapper.deleteById(id);
        flag = true;

        return flag;
    }

    @Override
    public Map<String, Object> getStorehouseById(int id) {

        Map<String, Object> map = new HashMap<>();

        OrgInfo orgInfo = orgInfoMapper.selectById(id);
        Map<String, Object> parm_map = new HashMap<>();
        parm_map.put("main_id", id);
        List<StorehouseClxx> list = storehouseClxxMapper.selectByMap(parm_map);
        if(list.size()>0){
        	orgInfo.setPz(list.get(0).getPz());
            orgInfo.setDj(list.get(0).getDj());
            orgInfo.setCnlsrz(list.get(0).getCrlsrl().toPlainString());
        }
        
        map.put("storehouse", orgInfo);
        return map;
    }
}
