package com.unissoft.utils;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class MyWebMvcConfigurer implements WebMvcConfigurer{

	@Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(new JWTInterceptor())
                .addPathPatterns("/**") // 其他非登录接口都需要进行token验证
                .excludePathPatterns("/userInfo/login","/n-basic-edge/getEdgeData","/point-data/getPoints/{houseId}","/equipmentTestingEnd","/scanning"); // 登录接口、接收边缘端数据、三维获取点的数据不用于token验证
                
    }
}
